version: 2

models:
  - name: bamboohr_base_mapping
    description: This model ties all departments to the last 12 months and is used in downstream models to do rolling 12 month metrics

  - name: bamboohr_budget_vs_actual
    description: Compares promotion budget spend to the budget aggregated at the division level.
    columns:
    - name: fiscal_quarter_name
    - name: division
    - name: fiscal_year
    - name: fiscal_quarter
    - name: budget
    - name: excess_from_previous_quarter
    - name: total_spend

  - name: bamboohr_headcount_intermediate
    description: This is the intermediate model to creating out the headcount report. This report provides headcounts, hires, separations by diversity fields, department, and division. Note - division is mapped to the last month in the report to account for 12 month calculations. 
    columns:
      - name: unique_key
        tests:
          - not_null
          - unique
      - name: month_date
      - name: breakout_type
        description: Explains the breakout of the data in the columns associated to this field.
        # tests:
        # - accepted_values:
        #   values: ['all_attributes_breakout','department_breakout', 'division_breakout', 'eeoc_breakout']
      - name: department
        description: This is using current department, and maps out historical department/divisions to the current mapping.
      - name: division
        description: This is using current division, and maps out historical department/divisions to the current mapping.
      - name: eeoc_field_name
        description: Identifies what eeoc field the data is associated to.
        # tests:
        # - accepted_values:
        #   values: ['no_eeoc','ethnicity','gender','region_modified','age_cohort','gender_region','ethnicity','urg_group']
      - name: eeoc_value
        description: This is the answer to the eeoc questions. For example, for the eeoc gender field we could have female, male, choose not to identify.
      - name: headcount_start
      - name: headcount_end
      - name: headcount_average
      - name: hire_count
      - name: separation_count
      - name: voluntary_separation
      - name: involuntary_separation
      - name: headcount_start_leader
      - name: headcount_end_leader
      - name: headcount_average_leader
      - name: hired_leaders
      - name: separated_leaders
      - name: headcount_start_manager
      - name: headcount_end_manager
      - name: headcount_average_manager
      - name: hired_manager
      - name: separated_manager
      - name: headcount_start_management
      - name: headcount_end_management
      - name: headcount_average_management
      - name: hired_management
      - name: headcount_start_staff
      - name: headcount_end_staff
      - name: headcount_average_staff
      - name: hired_staff
      - name: separated_staff
      - name: headcount_start_contributor
      - name: headcount_end_individual_contributor
      - name: headcount_average_contributor
      - name: hired_contributor
      - name: separated_contributor
      - name: promotion
      - name: location_factor
      - name: discretionary_bonus
        description: Identifies the total team members for the breakout and month that received a discretionary bonus_date
      - name: tenure_months
        description: Average tenure in months for team members based on end of month
      - name: tenure_zero_to_six_months
      - name: tenure_six_to_twelve_months
      - name: tenure_one_to_two_years
      - name: tenure_two_to_four_years
      - name: tenure_four_plus_years
      - name: breakout_type_modified
        description: This takes the current breakouts and adds in a company overall. 

  - name: bamboohr_id_employee_number_mapping
    description: This model is the canonical source mapping bamboo employee numbers with employee IDs. It includes all employees for all time. The model also captures demographic information, and removes test accounts.
    columns:
      - name: employee_id
        test: 
          - not_null
          - unique
      - name: employee_number
        test:
          - not_null
          - unique
      - name: first_name
      - name: last_name
      - name: hire_date
      - name: termination_date
      - name: age_cohort
        description: As based on current data.  
      - name: gender
      - name: nationality
      - name: region
      - name: region_modified
        description: Identifies if employee is in NORAM, LATAM, EMEA, or JAPAC region
      - name: gender_region
      - name: greenhouse_candidate_id
        description: Captures the id associated to the employee in Greenhouse (our recruiting platform). This will only be applicable in Greenhouse starting 2019-12-13, and will help identify which candidates were hired.
        tests: 
            - unique     

  - name: bamboohr_separations
    description: Provides a report of all separated team members. 

  - name: employee_directory
    description: Provides most recent record for all GitLab employees (active and separated).
    columns:
      - name: employee_id
        tests: 
          - unique
          - not_null
      - name: employee_number
        tests: 
          - unique
          - not_null
      - name: first_name
      - name: last_name
      - name: full_name
      - name: work_email
      - name: hire_date
      - name: rehire_date
      - name: termination_date
      - name: last_job_title
      - name: last_supervisor
      - name: last_department
      - name: last_division
      - name: last_cost_center
      - name: hire_location_factor
      - name: greenhouse_candidate_id


  - name: employee_locality
    description: This idenitifes the location factor for an employee on a given day starting 2020.03.24 by joining the locality value from bamboohr to the location_factor yaml or geo_zones yaml file to capture the location factor.
    tests:
      - dbt_utils.unique_combination_of_columns:
          combination_of_columns:
            - employee_number
            - updated_at
    columns:
      - name: employee_number
      - name: employee_id
      - name: updated_at
      - name: bamboo_locality
      - name: location_factor

  - name: workday_bamboohr_employment_status_xf
    description: The is a report for supporting the transition to Workday from BambooHR, to be compared to the normal table of the same name.

  - name: workday_bamboohr_id_employee_number_mapping
    description: The is a report for supporting the transition to Workday from BambooHR, to be compared to the normal table of the same name.

  - name: workday_bamboohr_job_role
    description: The is a report for supporting the transition to Workday from BambooHR, to be compared to the normal table of the same name.

  - name: workday_bamboohr_promotions_xf
    description: The is a report for supporting the transition to Workday from BambooHR, to be compared to the normal table of the same name.

  - name: workday_bamboohr_separations
    description: The is a report for supporting the transition to Workday from BambooHR, to be compared to the normal table of the same name.

  - name: workday_employee_directory_intermediate
    description: The is a report for supporting the transition to Workday from BambooHR, to be compared to the normal table of the same name.

  - name: workday_employee_directory
    description: The is a report for supporting the transition to Workday from BambooHR, to be compared to the normal table of the same name.

  - name: workday_employee_locality
    description: The is a report for supporting the transition to Workday from BambooHR, to be compared to the normal table of the same name.